import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
export { ContentChild, Type, forwardRef } from '@angular/core';
import { CommonModule } from '@angular/common';

let currentTemplateElement;
let firstVal = {};
/** Internal Helpers */
class Utils {
    static IterateAndGetChanges(obj) {
        if (ej.isNullOrUndefined(obj.tags) || obj.tags.length === 0) {
            return null;
        }
        let res = {};
        for (let i = 0, tags = obj.tags; i < tags.length; i++) {
            let tag = tags[i], tagElement = obj['tag_' + tag.replace(/\./g, '_')];
            if (!ej.isNullOrUndefined(tagElement) && tagElement.hasChanges) {
                res[tag] = tagElement.getChangesAndReset();
            }
        }
        return res;
    }
}
Utils.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: Utils, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
Utils.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: Utils });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: Utils, decorators: [{
            type: Injectable
        }] });
// tslint:disable-next-line:max-line-length
class BoldReportComponents {
    // tslint:disable-next-line:max-line-length
    constructor(controlName, el, cdRef, tags, ejIterableDiffers, _ejKeyValueDiffers) {
        this.controlName = controlName;
        this.el = el;
        this.cdRef = cdRef;
        this.tags = tags;
        this.ejIterableDiffers = ejIterableDiffers;
        this._ejKeyValueDiffers = _ejKeyValueDiffers;
        this.model = {};
        this.outputs = [];
        this.inputs = [];
        this.twoways = [];
        //        this.__shadow = this.dom.getShadowRoot(this.el.nativeElement);
        this.firstCheck = true;
        this.ejIterable = this.ejIterableDiffers.find([]).create(null);
        this.ejKeyValueDif = _ejKeyValueDiffers.find([]).create();
    }
    static bindAndRaiseEvent(instance, model, event) {
        if (!event.startsWith('model.')) { // && instance[event]['observers'].length > 1) {
            let originalEvt = event.startsWith('bold') ? event.substr(4) : event;
            model[originalEvt] = function (params) {
                instance[event + '_output']['emit'](params);
            };
        }
    }
    createTwoways(twoways) {
        if (!twoways) {
            return;
        }
        let model = this.model;
        for (let i = 0; i < twoways.length; i++) {
            let element = twoways[i].replace(/\_/g, '.');
            ej.createObject(element + 'Change', this[twoways[i] + '_twoChange'], model);
            ej.createObject(element, this.addTwoways(element), model);
        }
    }
    addTwoways(prop) {
        let model = this.model, value = firstVal; // , originalProp = prop.replace(/-/g, '.');
        return function (newVal, isApp) {
            if (value === firstVal) {
                value = ej.getObject(prop + '_two', model);
                if (value === undefined) {
                    value = ej.getObject(prop, this === undefined || this.defaults === undefined ? {} : this.defaults);
                }
            }
            if (newVal === undefined) {
                return value;
            }
            if (value === newVal) {
                return;
            }
            value = newVal;
            if (!isApp) {
                ej.createObject(prop + '_two', newVal, model);
                ej.getObject(prop + 'Change', model).emit(newVal);
            }
        };
    }
    ngOnInit() {
        for (let key in this) {
            if (key.indexOf('_input') != -1)
                this.inputs.push(key);
            if (key.indexOf('_output') != -1)
                this.outputs.push(key);
            if (key.indexOf('_two') != -1 && key.indexOf('_twoChange') == -1)
                this.twoways.push(key.replace('_two', ''));
        }
        if (ej.isNullOrUndefined(this['options'])) {
            this.createTwoways(this.twoways);
        }
    }
    ngAfterContentInit() {
        this.firstCheck = false;
        let model = this.model, events = this.outputs;
        if (events) {
            for (let i = 0; i < events.length; i++) {
                let event = events[i].replace('_output', '');
                BoldReportComponents.bindAndRaiseEvent(this, model, event);
            }
        }
        if (ej.isNullOrUndefined(this['options'])) {
            for (let i = 0; i < this.tags.length; i++) {
                let element = this.tags[i], item = this['tag_' + element.replace(/\./g, '_')];
                if (!ej.isNullOrUndefined(item)) {
                    ej.createObject(element, item.getList(), this.model);
                }
            }
            for (let i = 0; i < this.inputs.length; i++) {
                let property = this.inputs[i];
                let modelProperty = this.inputs[i].replace('_input', '');
                if (this[property] != null) {
                    if (modelProperty.indexOf('_') == -1) {
                        if (this.model[modelProperty]) {
                            $.extend(true, this.model[modelProperty], this[property]);
                        }
                        else {
                            this.model[modelProperty] = this[property];
                        }
                    }
                    else if (modelProperty.indexOf('_two') == -1) {
                        let tempObj = {};
                        let key = modelProperty.replace(/\_/g, '.');
                        ej.createObject(key, this[property], tempObj);
                        let rootProp = key.split('.')[0];
                        if (this.model[rootProp] == undefined)
                            this.model[rootProp] = {};
                        $.extend(true, this.model[rootProp], tempObj[rootProp]);
                    }
                }
            }
            for (let i = 0; i < this.twoways.length; i++) {
                let twoway = this.twoways[i];
                let twowayProperty = twoway + '_two';
                if (this[twowayProperty] != null) {
                    if (twoway.indexOf('_') == -1) {
                        this.model[twowayProperty] = this[twowayProperty];
                    }
                    else {
                        let tempObj = {};
                        let key = twoway.replace(/\_/g, '.') + '_two';
                        ej.createObject(key, this[twowayProperty], tempObj);
                        let rootProp = twowayProperty.split('_')[0];
                        $.extend(true, this.model[rootProp], tempObj[rootProp]);
                    }
                }
            }
        }
        else
            this.model = jQuery.extend(this.model, this['options']);
    }
    ngDoCheck() {
        if (ej.isNullOrUndefined(this['options'])) {
            this.twoways.forEach(element => {
                if (this[element + '_two'] instanceof Array) {
                    let changes = this.ejIterable.diff(this[element + '_two']);
                    if (changes) {
                        let ngChanges = {};
                        if (this.widget != undefined) {
                            ngChanges = this.getTwowayChanges(changes.collection, ngChanges, element.replace(/\_/g, '.'));
                            ej.createObject(element.replace(/\_/g, '.') + '.two', changes.collection, ngChanges);
                            this.widget['setModel'](ngChanges, $.isPlainObject(ngChanges));
                        }
                    }
                }
            });
        }
        else {
            let changes = this.ejKeyValueDif.diff(this['options']);
            if (changes) {
                if (this.widget != undefined) {
                    var ngchanges = {};
                    changes.forEachChangedItem((changedprop) => {
                        ej.createObject(changedprop.key, changedprop.currentValue, ngchanges);
                    });
                    this.widget['setModel'](ngchanges, $.isPlainObject(ngchanges));
                }
            }
        }
    }
    ngAfterViewInit() {
        let nativeElement = this.isEditor ? $(this.el.nativeElement.children) : $(this.el.nativeElement);
        let controlName = this.lowerCaseFirstLetter(this.controlName);
        this.widget = $(nativeElement)[controlName](this.model)[controlName]('instance');
    }
    lowerCaseFirstLetter(string) {
        return string[0].toLowerCase() + string.slice(1);
    }
    ngOnChanges(changes) {
        if (this.firstCheck) {
            return;
        }
        let ngChanges = {};
        if (ej.isNullOrUndefined(this['options'])) {
            for (let key in changes) {
                let element = changes[key];
                if (element.previousValue === element.currentValue) {
                    break;
                }
                key = key.replace('_input', '').replace(/\_/g, '.');
                if (key.endsWith('.two')) {
                    let oKey = key.replace('.two', '');
                    ngChanges = this.getTwowayChanges(element.currentValue, ngChanges, oKey);
                }
                ej.createObject(key, element.currentValue, ngChanges);
            }
            this.widget['setModel'](ngChanges, $.isPlainObject(ngChanges));
        }
    }
    getTwowayChanges(value, ngChanges, prop) {
        let valFn = ej.getObject(prop, this.widget['model']);
        valFn(value, true);
        ej.createObject(prop, valFn, ngChanges);
        return ngChanges;
    }
    ngAfterContentChecked() {
        // TODO: ChangeDetection Third/Multi level
        let changes = Utils.IterateAndGetChanges(this);
        for (let key in changes) {
            if (changes.hasOwnProperty(key)) {
                let element = changes[key];
                this.widget['_' + key](element);
            }
        }
    }
    ngOnDestroy() {
        this.widget['destroy']();
    }
}
BoldReportComponents.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportComponents, deps: "invalid", target: i0.ɵɵFactoryTarget.Injectable });
BoldReportComponents.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportComponents });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportComponents, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: undefined }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: Array }, { type: i0.IterableDiffers }, { type: i0.KeyValueDiffers }]; } });
class ComplexTagElement {
    // tags: Array<string>;
    constructor(tags) {
        this.tags = tags;
        this.valueChange = new EventEmitter();
        this.complexes = [];
        this.hasChanges = false;
        this.firstChange = true;
        Object.defineProperty(this, 'parent', {
            enumerable: false,
            writable: true,
            value: null
        });
        currentTemplateElement = this;
    }
    ngOnInit() {
        this.firstChange = false;
        for (let key in this) {
            if (key.indexOf('_') != -1 && key.indexOf('tag_') == -1)
                this.complexes.push(key);
        }
        for (let i = 0; i < this.complexes.length; i++) {
            let property = this.complexes[i];
            if (property.indexOf('_') != -1) {
                let tempObj = {};
                let key = property.replace(/\_/g, '.');
                ej.createObject(key, this[property], tempObj);
                let rootProp = key.split('.')[0];
                if (this[rootProp] == undefined)
                    this[rootProp] = {};
                $.extend(true, this[rootProp], tempObj[rootProp]);
            }
        }
    }
    ensureCleanObject() {
        let tags = this.tags;
        for (let i = 0; i < tags.length; i++) {
            let element = tags[i], tagElement = this['tag_' + element.replace(/\./g, '_')];
            if (i === 0 && this[element]) {
                return;
            }
            if (ej.isNullOrUndefined(tagElement)) {
                continue;
            }
            ej.createObject(element, tagElement.getList(), this);
        }
    }
    ngOnChanges(changes) {
        if (this.firstChange) {
            return;
        }
        this.recentChanges = changes;
        this.hasChanges = true;
    }
    getChangesAndReset() {
        if (this.hasChanges === false) {
            return;
        }
        let changes = this.recentChanges || {};
        let contentChanges = Utils.IterateAndGetChanges(this);
        if (!$.isEmptyObject(contentChanges)) {
            for (let key in contentChanges) {
                if (contentChanges.hasOwnProperty(key)) {
                    let element = contentChanges[key];
                    // this.el.nativeElement.
                    if (!ej.isNullOrUndefined(this.parent.widget['_' + this.property.replace(/\./g, '_') + '_' + key]))
                        this.parent.widget['_' + this.property.replace(/\./g, '_') + '_' + key](element);
                }
            }
        }
        this.hasChanges = false;
        return changes;
    }
    ngAfterContentChecked() {
        let tags = this.tags;
        for (let i = 0, len = tags.length; i < len; i++) {
            let element = tags[i], tagElement = this['tag_' + element.replace(/\./g, '_')];
            if (tagElement && tagElement.hasChanges) {
                this.hasChanges = true;
            }
        }
    }
}
ComplexTagElement.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: ComplexTagElement, deps: [{ token: Array }], target: i0.ɵɵFactoryTarget.Injectable });
ComplexTagElement.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: ComplexTagElement });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: ComplexTagElement, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: Array }]; } });
class ArrayTagElement {
    constructor(propertyName) {
        this.propertyName = propertyName;
        this.hasChanges = false;
    }
    // TODO: Need to consider dynamic child change
    ngAfterContentInit() {
        let index = 0;
        this.list = this.children.map((child) => {
            child.index = index++;
            child.property = this.propertyName;
            return child;
        });
    }
    getList() {
        let list = this.list;
        for (let i = 0; i < list.length; i++) {
            list[i].ensureCleanObject();
        }
        return list;
    }
    getChangesAndReset() {
        this.hasChanges = false;
        return this.recentChanges;
    }
    ngAfterContentChecked() {
        let changes = {}, res = changes[this.propertyName] = [], childChange;
        for (let i = 0, list = this.list; i < list.length; i++) {
            let child = list[i];
            if (child.hasChanges) {
                childChange = child.getChangesAndReset();
                if (!ej.isNullOrUndefined(childChange)) {
                    res.push({
                        index: child.index,
                        change: childChange
                    });
                }
            }
        }
        if (res.length > 0) {
            this.recentChanges = res;
            this.hasChanges = true;
        }
    }
}
ArrayTagElement.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: ArrayTagElement, deps: "invalid", target: i0.ɵɵFactoryTarget.Injectable });
ArrayTagElement.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: ArrayTagElement });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: ArrayTagElement, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: undefined }]; } });

class BoldReportViewerComponent extends BoldReportComponents {
    // tslint:disable-next-line:max-line-length
    constructor(el, cdRef, _ejIterableDiffers, _ejkeyvaluediffers) {
        super('BoldReportViewer', el, cdRef, [], _ejIterableDiffers, _ejkeyvaluediffers);
        this.el = el;
        this.cdRef = cdRef;
        this._ejIterableDiffers = _ejIterableDiffers;
        this._ejkeyvaluediffers = _ejkeyvaluediffers;
        this.drillThrough_output = new EventEmitter();
        this.renderingBegin_output = new EventEmitter();
        this.renderingComplete_output = new EventEmitter();
        this.reportError_output = new EventEmitter();
        this.reportExport_output = new EventEmitter();
        this.reportLoaded_output = new EventEmitter();
        this.reportCanceled_output = new EventEmitter();
        this.showError_output = new EventEmitter();
        this.viewReportClick_output = new EventEmitter();
        this.ajaxBeforeLoad_output = new EventEmitter();
        this.ajaxSuccess_output = new EventEmitter();
        this.ajaxError_output = new EventEmitter();
        this.toolbarRendering_output = new EventEmitter();
        this.exportProgressChanged_output = new EventEmitter();
        this.printProgressChanged_output = new EventEmitter();
        this.exportItemClick_output = new EventEmitter();
        this.toolBarItemClick_output = new EventEmitter();
        this.hyperlink_output = new EventEmitter();
        this.reportPrint_output = new EventEmitter();
        this.beforeParameterAdd_output = new EventEmitter();
    }
}
BoldReportViewerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportViewerComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i0.IterableDiffers }, { token: i0.KeyValueDiffers }], target: i0.ɵɵFactoryTarget.Component });
BoldReportViewerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.0.0", type: BoldReportViewerComponent, selector: "bold-reportviewer", inputs: { dataSources_input: ["dataSources", "dataSources_input"], exportSettings_input: ["exportSettings", "exportSettings_input"], isResponsive_input: ["isResponsive", "isResponsive_input"], locale_input: ["locale", "locale_input"], pageSettings_input: ["pageSettings", "pageSettings_input"], parameters_input: ["parameters", "parameters_input"], extendedAttributes_input: ["extendedAttributes", "extendedAttributes_input"], toolbarSettings_input: ["toolbarSettings", "toolbarSettings_input"], parameterSettings_input: ["parameterSettings", "parameterSettings_input"], printMode_input: ["printMode", "printMode_input"], printOption_input: ["printOption", "printOption_input"], processingMode_input: ["processingMode", "processingMode_input"], renderMode_input: ["renderMode", "renderMode_input"], reportPath_input: ["reportPath", "reportPath_input"], reportServerUrl_input: ["reportServerUrl", "reportServerUrl_input"], reportServiceUrl_input: ["reportServiceUrl", "reportServiceUrl_input"], zoomFactor_input: ["zoomFactor", "zoomFactor_input"], serviceAuthorizationToken_input: ["serviceAuthorizationToken", "serviceAuthorizationToken_input"], embedToken_input: ["embedToken", "embedToken_input"], toolbarRenderMode_input: ["toolbarRenderMode", "toolbarRenderMode_input"], enableParameterBlockScroller_input: ["enableParameterBlockScroller", "enableParameterBlockScroller_input"], enableDatasourceBlockScroller_input: ["enableDatasourceBlockScroller", "enableDatasourceBlockScroller_input"], sizeToReportContent_input: ["sizeToReportContent", "sizeToReportContent_input"], autoRender_input: ["autoRender", "autoRender_input"], enableNotificationBar_input: ["enableNotificationBar", "enableNotificationBar_input"], enableDropDownSearch_input: ["enableDropDownSearch", "enableDropDownSearch_input"], enableVirtualEvaluation_input: ["enableVirtualEvaluation", "enableVirtualEvaluation_input"], smartRendering_input: ["smartRendering", "smartRendering_input"], waitingPopupTemplate_input: ["waitingPopupTemplate", "waitingPopupTemplate_input"], enableOnScrollNavigation_input: ["enableOnScrollNavigation", "enableOnScrollNavigation_input"], customBrandSettings_input: ["customBrandSettings", "customBrandSettings_input"], customBrandSettings_link_input: ["customBrandSettings.link", "customBrandSettings_link_input"], customBrandSettings_domain_input: ["customBrandSettings.domain", "customBrandSettings_domain_input"], customBrandSettings_name_input: ["customBrandSettings.name", "customBrandSettings_name_input"], customBrandSettings_links_input: ["customBrandSettings.links", "customBrandSettings_links_input"], dataSources_name_input: ["dataSources.name", "dataSources_name_input"], dataSources_value_input: ["dataSources.value", "dataSources_value_input"], exportSettings_exportOptions_input: ["exportSettings.exportOptions", "exportSettings_exportOptions_input"], exportSettings_excelFormat_input: ["exportSettings.excelFormat", "exportSettings_excelFormat_input"], exportSettings_wordFormat_input: ["exportSettings.wordFormat", "exportSettings_wordFormat_input"], exportSettings_customItems_input: ["exportSettings.customItems", "exportSettings_customItems_input"], exportSettings_ImageQuality_input: ["exportSettings.ImageQuality", "exportSettings_ImageQuality_input"], exportSettings_UsePrintSizes_input: ["exportSettings.UsePrintSizes", "exportSettings_UsePrintSizes_input"], pageSettings_orientation_input: ["pageSettings.orientation", "pageSettings_orientation_input"], pageSettings_paperSize_input: ["pageSettings.paperSize", "pageSettings_paperSize_input"], pageSettings_height_input: ["pageSettings.height", "pageSettings_height_input"], pageSettings_width_input: ["pageSettings.width", "pageSettings_width_input"], pageSettings_margins_input: ["pageSettings.margins", "pageSettings_margins_input"], pageSettings_hidePageOrientation_input: ["pageSettings.hidePageOrientation", "pageSettings_hidePageOrientation_input"], pageSettings_hidePagePaperSizes_input: ["pageSettings.hidePagePaperSizes", "pageSettings_hidePagePaperSizes_input"], parameters_labels_input: ["parameters.labels", "parameters_labels_input"], parameters_name_input: ["parameters.name", "parameters_name_input"], parameters_nullable_input: ["parameters.nullable", "parameters_nullable_input"], parameters_prompt_input: ["parameters.prompt", "parameters_prompt_input"], parameters_values_input: ["parameters.values", "parameters_values_input"], parameterSettings_delimiterChar_input: ["parameterSettings.delimiterChar", "parameterSettings_delimiterChar_input"], parameterSettings_position_input: ["parameterSettings.position", "parameterSettings_position_input"], parameterSettings_popupHeight_input: ["parameterSettings.popupHeight", "parameterSettings_popupHeight_input"], parameterSettings_popupWidth_input: ["parameterSettings.popupWidth", "parameterSettings_popupWidth_input"], parameterSettings_itemWidth_input: ["parameterSettings.itemWidth", "parameterSettings_itemWidth_input"], parameterSettings_labelWidth_input: ["parameterSettings.labelWidth", "parameterSettings_labelWidth_input"], parameterSettings_minDateTime_input: ["parameterSettings.minDateTime", "parameterSettings_minDateTime_input"], parameterSettings_maxDateTime_input: ["parameterSettings.maxDateTime", "parameterSettings_maxDateTime_input"], parameterSettings_hideTooltip_input: ["parameterSettings.hideTooltip", "parameterSettings_hideTooltip_input"], parameterSettings_enablePopupResize_input: ["parameterSettings.enablePopupResize", "parameterSettings_enablePopupResize_input"], parameterSettings_hideParameterBlock_input: ["parameterSettings.hideParameterBlock", "parameterSettings_hideParameterBlock_input"], parameterSettings_dateTimeFormat_input: ["parameterSettings.dateTimeFormat", "parameterSettings_dateTimeFormat_input"], parameterSettings_timeDisplayFormat_input: ["parameterSettings.timeDisplayFormat", "parameterSettings_timeDisplayFormat_input"], parameterSettings_timeInterval_input: ["parameterSettings.timeInterval", "parameterSettings_timeInterval_input"], parameterSettings_accessInternalValue_input: ["parameterSettings.accessInternalValue", "parameterSettings_accessInternalValue_input"], toolbarSettings_click_input: ["toolbarSettings.click", "toolbarSettings_click_input"], toolbarSettings_items_input: ["toolbarSettings.items", "toolbarSettings_items_input"], toolbarSettings_toolbars_input: ["toolbarSettings.toolbars", "toolbarSettings_toolbars_input"], toolbarSettings_showToolbar_input: ["toolbarSettings.showToolbar", "toolbarSettings_showToolbar_input"], toolbarSettings_showTooltip_input: ["toolbarSettings.showTooltip", "toolbarSettings_showTooltip_input"], toolbarSettings_autoHide_input: ["toolbarSettings.autoHide", "toolbarSettings_autoHide_input"], toolbarSettings_autoHideDelay_input: ["toolbarSettings.autoHideDelay", "toolbarSettings_autoHideDelay_input"], toolbarSettings_templateId_input: ["toolbarSettings.templateId", "toolbarSettings_templateId_input"], toolbarSettings_customItems_input: ["toolbarSettings.customItems", "toolbarSettings_customItems_input"], toolbarSettings_customGroups_input: ["toolbarSettings.customGroups", "toolbarSettings_customGroups_input"] }, outputs: { drillThrough_output: "drillThrough", renderingBegin_output: "renderingBegin", renderingComplete_output: "renderingComplete", reportError_output: "reportError", reportExport_output: "reportExport", reportLoaded_output: "reportLoaded", reportCanceled_output: "reportCanceled", showError_output: "showError", viewReportClick_output: "viewReportClick", ajaxBeforeLoad_output: "ajaxBeforeLoad", ajaxSuccess_output: "ajaxSuccess", ajaxError_output: "ajaxError", toolbarRendering_output: "toolbarRendering", exportProgressChanged_output: "exportProgressChanged", printProgressChanged_output: "printProgressChanged", exportItemClick_output: "exportItemClick", toolBarItemClick_output: "toolBarItemClick", hyperlink_output: "hyperlink", reportPrint_output: "reportPrint", beforeParameterAdd_output: "beforeParameterAdd" }, usesInheritance: true, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportViewerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'bold-reportviewer',
                    template: ''
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i0.IterableDiffers }, { type: i0.KeyValueDiffers }]; }, propDecorators: { dataSources_input: [{
                type: Input,
                args: ['dataSources']
            }], exportSettings_input: [{
                type: Input,
                args: ['exportSettings']
            }], isResponsive_input: [{
                type: Input,
                args: ['isResponsive']
            }], locale_input: [{
                type: Input,
                args: ['locale']
            }], pageSettings_input: [{
                type: Input,
                args: ['pageSettings']
            }], parameters_input: [{
                type: Input,
                args: ['parameters']
            }], extendedAttributes_input: [{
                type: Input,
                args: ['extendedAttributes']
            }], toolbarSettings_input: [{
                type: Input,
                args: ['toolbarSettings']
            }], parameterSettings_input: [{
                type: Input,
                args: ['parameterSettings']
            }], printMode_input: [{
                type: Input,
                args: ['printMode']
            }], printOption_input: [{
                type: Input,
                args: ['printOption']
            }], processingMode_input: [{
                type: Input,
                args: ['processingMode']
            }], renderMode_input: [{
                type: Input,
                args: ['renderMode']
            }], reportPath_input: [{
                type: Input,
                args: ['reportPath']
            }], reportServerUrl_input: [{
                type: Input,
                args: ['reportServerUrl']
            }], reportServiceUrl_input: [{
                type: Input,
                args: ['reportServiceUrl']
            }], zoomFactor_input: [{
                type: Input,
                args: ['zoomFactor']
            }], serviceAuthorizationToken_input: [{
                type: Input,
                args: ['serviceAuthorizationToken']
            }], embedToken_input: [{
                type: Input,
                args: ['embedToken']
            }], toolbarRenderMode_input: [{
                type: Input,
                args: ['toolbarRenderMode']
            }], enableParameterBlockScroller_input: [{
                type: Input,
                args: ['enableParameterBlockScroller']
            }], enableDatasourceBlockScroller_input: [{
                type: Input,
                args: ['enableDatasourceBlockScroller']
            }], sizeToReportContent_input: [{
                type: Input,
                args: ['sizeToReportContent']
            }], autoRender_input: [{
                type: Input,
                args: ['autoRender']
            }], enableNotificationBar_input: [{
                type: Input,
                args: ['enableNotificationBar']
            }], enableDropDownSearch_input: [{
                type: Input,
                args: ['enableDropDownSearch']
            }], enableVirtualEvaluation_input: [{
                type: Input,
                args: ['enableVirtualEvaluation']
            }], smartRendering_input: [{
                type: Input,
                args: ['smartRendering']
            }], waitingPopupTemplate_input: [{
                type: Input,
                args: ['waitingPopupTemplate']
            }], enableOnScrollNavigation_input: [{
                type: Input,
                args: ['enableOnScrollNavigation']
            }], customBrandSettings_input: [{
                type: Input,
                args: ['customBrandSettings']
            }], customBrandSettings_link_input: [{
                type: Input,
                args: ['customBrandSettings.link']
            }], customBrandSettings_domain_input: [{
                type: Input,
                args: ['customBrandSettings.domain']
            }], customBrandSettings_name_input: [{
                type: Input,
                args: ['customBrandSettings.name']
            }], customBrandSettings_links_input: [{
                type: Input,
                args: ['customBrandSettings.links']
            }], dataSources_name_input: [{
                type: Input,
                args: ['dataSources.name']
            }], dataSources_value_input: [{
                type: Input,
                args: ['dataSources.value']
            }], exportSettings_exportOptions_input: [{
                type: Input,
                args: ['exportSettings.exportOptions']
            }], exportSettings_excelFormat_input: [{
                type: Input,
                args: ['exportSettings.excelFormat']
            }], exportSettings_wordFormat_input: [{
                type: Input,
                args: ['exportSettings.wordFormat']
            }], exportSettings_customItems_input: [{
                type: Input,
                args: ['exportSettings.customItems']
            }], exportSettings_ImageQuality_input: [{
                type: Input,
                args: ['exportSettings.ImageQuality']
            }], exportSettings_UsePrintSizes_input: [{
                type: Input,
                args: ['exportSettings.UsePrintSizes']
            }], pageSettings_orientation_input: [{
                type: Input,
                args: ['pageSettings.orientation']
            }], pageSettings_paperSize_input: [{
                type: Input,
                args: ['pageSettings.paperSize']
            }], pageSettings_height_input: [{
                type: Input,
                args: ['pageSettings.height']
            }], pageSettings_width_input: [{
                type: Input,
                args: ['pageSettings.width']
            }], pageSettings_margins_input: [{
                type: Input,
                args: ['pageSettings.margins']
            }], pageSettings_hidePageOrientation_input: [{
                type: Input,
                args: ['pageSettings.hidePageOrientation']
            }], pageSettings_hidePagePaperSizes_input: [{
                type: Input,
                args: ['pageSettings.hidePagePaperSizes']
            }], parameters_labels_input: [{
                type: Input,
                args: ['parameters.labels']
            }], parameters_name_input: [{
                type: Input,
                args: ['parameters.name']
            }], parameters_nullable_input: [{
                type: Input,
                args: ['parameters.nullable']
            }], parameters_prompt_input: [{
                type: Input,
                args: ['parameters.prompt']
            }], parameters_values_input: [{
                type: Input,
                args: ['parameters.values']
            }], parameterSettings_delimiterChar_input: [{
                type: Input,
                args: ['parameterSettings.delimiterChar']
            }], parameterSettings_position_input: [{
                type: Input,
                args: ['parameterSettings.position']
            }], parameterSettings_popupHeight_input: [{
                type: Input,
                args: ['parameterSettings.popupHeight']
            }], parameterSettings_popupWidth_input: [{
                type: Input,
                args: ['parameterSettings.popupWidth']
            }], parameterSettings_itemWidth_input: [{
                type: Input,
                args: ['parameterSettings.itemWidth']
            }], parameterSettings_labelWidth_input: [{
                type: Input,
                args: ['parameterSettings.labelWidth']
            }], parameterSettings_minDateTime_input: [{
                type: Input,
                args: ['parameterSettings.minDateTime']
            }], parameterSettings_maxDateTime_input: [{
                type: Input,
                args: ['parameterSettings.maxDateTime']
            }], parameterSettings_hideTooltip_input: [{
                type: Input,
                args: ['parameterSettings.hideTooltip']
            }], parameterSettings_enablePopupResize_input: [{
                type: Input,
                args: ['parameterSettings.enablePopupResize']
            }], parameterSettings_hideParameterBlock_input: [{
                type: Input,
                args: ['parameterSettings.hideParameterBlock']
            }], parameterSettings_dateTimeFormat_input: [{
                type: Input,
                args: ['parameterSettings.dateTimeFormat']
            }], parameterSettings_timeDisplayFormat_input: [{
                type: Input,
                args: ['parameterSettings.timeDisplayFormat']
            }], parameterSettings_timeInterval_input: [{
                type: Input,
                args: ['parameterSettings.timeInterval']
            }], parameterSettings_accessInternalValue_input: [{
                type: Input,
                args: ['parameterSettings.accessInternalValue']
            }], toolbarSettings_click_input: [{
                type: Input,
                args: ['toolbarSettings.click']
            }], toolbarSettings_items_input: [{
                type: Input,
                args: ['toolbarSettings.items']
            }], toolbarSettings_toolbars_input: [{
                type: Input,
                args: ['toolbarSettings.toolbars']
            }], toolbarSettings_showToolbar_input: [{
                type: Input,
                args: ['toolbarSettings.showToolbar']
            }], toolbarSettings_showTooltip_input: [{
                type: Input,
                args: ['toolbarSettings.showTooltip']
            }], toolbarSettings_autoHide_input: [{
                type: Input,
                args: ['toolbarSettings.autoHide']
            }], toolbarSettings_autoHideDelay_input: [{
                type: Input,
                args: ['toolbarSettings.autoHideDelay']
            }], toolbarSettings_templateId_input: [{
                type: Input,
                args: ['toolbarSettings.templateId']
            }], toolbarSettings_customItems_input: [{
                type: Input,
                args: ['toolbarSettings.customItems']
            }], toolbarSettings_customGroups_input: [{
                type: Input,
                args: ['toolbarSettings.customGroups']
            }], drillThrough_output: [{
                type: Output,
                args: ['drillThrough']
            }], renderingBegin_output: [{
                type: Output,
                args: ['renderingBegin']
            }], renderingComplete_output: [{
                type: Output,
                args: ['renderingComplete']
            }], reportError_output: [{
                type: Output,
                args: ['reportError']
            }], reportExport_output: [{
                type: Output,
                args: ['reportExport']
            }], reportLoaded_output: [{
                type: Output,
                args: ['reportLoaded']
            }], reportCanceled_output: [{
                type: Output,
                args: ['reportCanceled']
            }], showError_output: [{
                type: Output,
                args: ['showError']
            }], viewReportClick_output: [{
                type: Output,
                args: ['viewReportClick']
            }], ajaxBeforeLoad_output: [{
                type: Output,
                args: ['ajaxBeforeLoad']
            }], ajaxSuccess_output: [{
                type: Output,
                args: ['ajaxSuccess']
            }], ajaxError_output: [{
                type: Output,
                args: ['ajaxError']
            }], toolbarRendering_output: [{
                type: Output,
                args: ['toolbarRendering']
            }], exportProgressChanged_output: [{
                type: Output,
                args: ['exportProgressChanged']
            }], printProgressChanged_output: [{
                type: Output,
                args: ['printProgressChanged']
            }], exportItemClick_output: [{
                type: Output,
                args: ['exportItemClick']
            }], toolBarItemClick_output: [{
                type: Output,
                args: ['toolBarItemClick']
            }], hyperlink_output: [{
                type: Output,
                args: ['hyperlink']
            }], reportPrint_output: [{
                type: Output,
                args: ['reportPrint']
            }], beforeParameterAdd_output: [{
                type: Output,
                args: ['beforeParameterAdd']
            }] } });

class BoldReportViewerModule {
}
BoldReportViewerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportViewerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BoldReportViewerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportViewerModule, declarations: [BoldReportViewerComponent], imports: [CommonModule], exports: [BoldReportViewerComponent] });
BoldReportViewerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportViewerModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportViewerModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [
                        BoldReportViewerComponent
                    ],
                    exports: [
                        BoldReportViewerComponent
                    ]
                }]
        }] });

class BoldReportDesignerComponent extends BoldReportComponents {
    // tslint:disable-next-line:max-line-length
    constructor(el, cdRef, _ejIterableDiffers, _ejkeyvaluediffers) {
        super('BoldReportDesigner', el, cdRef, [], _ejIterableDiffers, _ejkeyvaluediffers);
        this.el = el;
        this.cdRef = cdRef;
        this._ejIterableDiffers = _ejIterableDiffers;
        this._ejkeyvaluediffers = _ejkeyvaluediffers;
        this.ajaxBeforeLoad_output = new EventEmitter();
        this.ajaxError_output = new EventEmitter();
        this.ajaxSuccess_output = new EventEmitter();
        this.create_output = new EventEmitter();
        this.destroy_output = new EventEmitter();
        this.newDataClick_output = new EventEmitter();
        this.openReportClick_output = new EventEmitter();
        this.previewReport_output = new EventEmitter();
        this.reportModified_output = new EventEmitter();
        this.reportOpened_output = new EventEmitter();
        this.reportSaved_output = new EventEmitter();
        this.saveReportClick_output = new EventEmitter();
        this.toolbarClick_output = new EventEmitter();
        this.toolbarRendering_output = new EventEmitter();
        this.encryptData_output = new EventEmitter();
        this.decryptData_output = new EventEmitter();
    }
}
BoldReportDesignerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportDesignerComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i0.IterableDiffers }, { token: i0.KeyValueDiffers }], target: i0.ɵɵFactoryTarget.Component });
BoldReportDesignerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.0.0", type: BoldReportDesignerComponent, selector: "bold-reportdesigner", inputs: { configurePaneSettings_input: ["configurePaneSettings", "configurePaneSettings_input"], dataTabIndex_input: ["dataTabIndex", "dataTabIndex_input"], disableCodeModule_input: ["disableCodeModule", "disableCodeModule_input"], enableRuler_input: ["enableRuler", "enableRuler_input"], enablePageMargin_input: ["enablePageMargin", "enablePageMargin_input"], embedToken_input: ["embedToken", "embedToken_input"], enableImpersonate_input: ["enableImpersonate", "enableImpersonate_input"], enableImageBlobing_input: ["enableImageBlobing", "enableImageBlobing_input"], enableTableMultipleDataAssign_input: ["enableTableMultipleDataAssign", "enableTableMultipleDataAssign_input"], filterDataConnectors_input: ["filterDataConnectors", "filterDataConnectors_input"], filterReportItems_input: ["filterReportItems", "filterReportItems_input"], fontNames_input: ["fontNames", "fontNames_input"], locale_input: ["locale", "locale_input"], permissionSettings_input: ["permissionSettings", "permissionSettings_input"], previewOptions_input: ["previewOptions", "previewOptions_input"], reportDataExtensions_input: ["reportDataExtensions", "reportDataExtensions_input"], reportItemExtensions_input: ["reportItemExtensions", "reportItemExtensions_input"], reportPath_input: ["reportPath", "reportPath_input"], reportVersion_input: ["reportVersion", "reportVersion_input"], reportType_input: ["reportType", "reportType_input"], reportServerUrl_input: ["reportServerUrl", "reportServerUrl_input"], serviceAuthorizationToken_input: ["serviceAuthorizationToken", "serviceAuthorizationToken_input"], serviceUrl_input: ["serviceUrl", "serviceUrl_input"], toolbarSettings_input: ["toolbarSettings", "toolbarSettings_input"], waitingPopupTemplate_input: ["waitingPopupTemplate", "waitingPopupTemplate_input"], zoomFactor_input: ["zoomFactor", "zoomFactor_input"], configurePaneSettings_items_input: ["configurePaneSettings.items", "configurePaneSettings_items_input"], configurePaneSettings_showPane_input: ["configurePaneSettings.showPane", "configurePaneSettings_showPane_input"], dataSources_name_input: ["dataSources.name", "dataSources_name_input"], dataSources_value_input: ["dataSources.value", "dataSources_value_input"], exportSettings_exportOptions_input: ["exportSettings.exportOptions", "exportSettings_exportOptions_input"], exportSettings_excelFormat_input: ["exportSettings.excelFormat", "exportSettings_excelFormat_input"], exportSettings_wordFormat_input: ["exportSettings.wordFormat", "exportSettings_wordFormat_input"], exportSettings_customItems_input: ["exportSettings.customItems", "exportSettings_customItems_input"], pageSettings_orientation_input: ["pageSettings.orientation", "pageSettings_orientation_input"], pageSettings_paperSize_input: ["pageSettings.paperSize", "pageSettings_paperSize_input"], pageSettings_height_input: ["pageSettings.height", "pageSettings_height_input"], pageSettings_width_input: ["pageSettings.width", "pageSettings_width_input"], pageSettings_margins_input: ["pageSettings.margins", "pageSettings_margins_input"], pageSettings_hidePageOrientation_input: ["pageSettings.hidePageOrientation", "pageSettings_hidePageOrientation_input"], parameters_labels_input: ["parameters.labels", "parameters_labels_input"], parameters_name_input: ["parameters.name", "parameters_name_input"], parameters_nullable_input: ["parameters.nullable", "parameters_nullable_input"], parameters_prompt_input: ["parameters.prompt", "parameters_prompt_input"], parameters_values_input: ["parameters.values", "parameters_values_input"], parameterSettings_delimiterChar_input: ["parameterSettings.delimiterChar", "parameterSettings_delimiterChar_input"], parameterSettings_popupHeight_input: ["parameterSettings.popupHeight", "parameterSettings_popupHeight_input"], parameterSettings_popupWidth_input: ["parameterSettings.popupWidth", "parameterSettings_popupWidth_input"], parameterSettings_itemWidth_input: ["parameterSettings.itemWidth", "parameterSettings_itemWidth_input"], parameterSettings_labelWidth_input: ["parameterSettings.labelWidth", "parameterSettings_labelWidth_input"], permissionSettings_dataSet_input: ["permissionSettings.dataSet", "permissionSettings_dataSet_input"], permissionSettings_dataSource_input: ["permissionSettings.dataSource", "permissionSettings_dataSource_input"], previewOptions_autoRender_input: ["previewOptions.autoRender", "previewOptions_autoRender_input"], previewOptions_dataSources_input: ["previewOptions.dataSources", "previewOptions_dataSources_input"], previewOptions_enableNotificationBar_input: ["previewOptions.enableNotificationBar", "previewOptions_enableNotificationBar_input"], previewOptions_enableVirtualEvaluation_input: ["previewOptions.enableVirtualEvaluation", "previewOptions_enableVirtualEvaluation_input"], previewOptions_enableParameterBlockScroller_input: ["previewOptions.enableParameterBlockScroller", "previewOptions_enableParameterBlockScroller_input"], previewOptions_enableDatasourceBlockScroller_input: ["previewOptions.enableDatasourceBlockScroller", "previewOptions_enableDatasourceBlockScroller_input"], previewOptions_enableDropDownSearch_input: ["previewOptions.enableDropDownSearch", "previewOptions_enableDropDownSearch_input"], previewOptions_exportSettings_input: ["previewOptions.exportSettings", "previewOptions_exportSettings_input"], previewOptions_pageSettings_input: ["previewOptions.pageSettings", "previewOptions_pageSettings_input"], previewOptions_parameters_input: ["previewOptions.parameters", "previewOptions_parameters_input"], previewOptions_parameterSettings_input: ["previewOptions.parameterSettings", "previewOptions_parameterSettings_input"], previewOptions_printMode_input: ["previewOptions.printMode", "previewOptions_printMode_input"], previewOptions_printOption_input: ["previewOptions.printOption", "previewOptions_printOption_input"], previewOptions_sizeToReportContent_input: ["previewOptions.sizeToReportContent", "previewOptions_sizeToReportContent_input"], previewOptions_toolbarSettings_input: ["previewOptions.toolbarSettings", "previewOptions_toolbarSettings_input"], previewOptions_zoomFactor_input: ["previewOptions.zoomFactor", "previewOptions_zoomFactor_input"], reportDataExtensions_name_input: ["reportDataExtensions.name", "reportDataExtensions_name_input"], reportDataExtensions_className_input: ["reportDataExtensions.className", "reportDataExtensions_className_input"], reportDataExtensions_imageClass_input: ["reportDataExtensions.imageClass", "reportDataExtensions_imageClass_input"], reportDataExtensions_displayName_input: ["reportDataExtensions.displayName", "reportDataExtensions_displayName_input"], reportItemExtensions_name_input: ["reportItemExtensions.name", "reportItemExtensions_name_input"], reportItemExtensions_className_input: ["reportItemExtensions.className", "reportItemExtensions_className_input"], reportItemExtensions_imageClass_input: ["reportItemExtensions.imageClass", "reportItemExtensions_imageClass_input"], reportItemExtensions_displayName_input: ["reportItemExtensions.displayName", "reportItemExtensions_displayName_input"], reportItemExtensions_category_input: ["reportItemExtensions.category", "reportItemExtensions_category_input"], reportItemExtensions_allowHeaderFooter_input: ["reportItemExtensions.allowHeaderFooter", "reportItemExtensions_allowHeaderFooter_input"], toolbarSettings_items_input: ["toolbarSettings.items", "toolbarSettings_items_input"], toolbarSettings_showToolbar_input: ["toolbarSettings.showToolbar", "toolbarSettings_showToolbar_input"], toolbarSettings_templateId_input: ["toolbarSettings.templateId", "toolbarSettings_templateId_input"] }, outputs: { ajaxBeforeLoad_output: "ajaxBeforeLoad", ajaxError_output: "ajaxError", ajaxSuccess_output: "ajaxSuccess", create_output: "create", destroy_output: "destroy", newDataClick_output: "newDataClick", openReportClick_output: "openReportClick", previewReport_output: "previewReport", reportModified_output: "reportModified", reportOpened_output: "reportOpened", reportSaved_output: "reportSaved", saveReportClick_output: "saveReportClick", toolbarClick_output: "toolbarClick", toolbarRendering_output: "toolbarRendering", encryptData_output: "encryptData", decryptData_output: "decryptData" }, usesInheritance: true, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportDesignerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'bold-reportdesigner',
                    template: ''
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i0.IterableDiffers }, { type: i0.KeyValueDiffers }]; }, propDecorators: { configurePaneSettings_input: [{
                type: Input,
                args: ['configurePaneSettings']
            }], dataTabIndex_input: [{
                type: Input,
                args: ['dataTabIndex']
            }], disableCodeModule_input: [{
                type: Input,
                args: ['disableCodeModule']
            }], enableRuler_input: [{
                type: Input,
                args: ['enableRuler']
            }], enablePageMargin_input: [{
                type: Input,
                args: ['enablePageMargin']
            }], embedToken_input: [{
                type: Input,
                args: ['embedToken']
            }], enableImpersonate_input: [{
                type: Input,
                args: ['enableImpersonate']
            }], enableImageBlobing_input: [{
                type: Input,
                args: ['enableImageBlobing']
            }], enableTableMultipleDataAssign_input: [{
                type: Input,
                args: ['enableTableMultipleDataAssign']
            }], filterDataConnectors_input: [{
                type: Input,
                args: ['filterDataConnectors']
            }], filterReportItems_input: [{
                type: Input,
                args: ['filterReportItems']
            }], fontNames_input: [{
                type: Input,
                args: ['fontNames']
            }], locale_input: [{
                type: Input,
                args: ['locale']
            }], permissionSettings_input: [{
                type: Input,
                args: ['permissionSettings']
            }], previewOptions_input: [{
                type: Input,
                args: ['previewOptions']
            }], reportDataExtensions_input: [{
                type: Input,
                args: ['reportDataExtensions']
            }], reportItemExtensions_input: [{
                type: Input,
                args: ['reportItemExtensions']
            }], reportPath_input: [{
                type: Input,
                args: ['reportPath']
            }], reportVersion_input: [{
                type: Input,
                args: ['reportVersion']
            }], reportType_input: [{
                type: Input,
                args: ['reportType']
            }], reportServerUrl_input: [{
                type: Input,
                args: ['reportServerUrl']
            }], serviceAuthorizationToken_input: [{
                type: Input,
                args: ['serviceAuthorizationToken']
            }], serviceUrl_input: [{
                type: Input,
                args: ['serviceUrl']
            }], toolbarSettings_input: [{
                type: Input,
                args: ['toolbarSettings']
            }], waitingPopupTemplate_input: [{
                type: Input,
                args: ['waitingPopupTemplate']
            }], zoomFactor_input: [{
                type: Input,
                args: ['zoomFactor']
            }], configurePaneSettings_items_input: [{
                type: Input,
                args: ['configurePaneSettings.items']
            }], configurePaneSettings_showPane_input: [{
                type: Input,
                args: ['configurePaneSettings.showPane']
            }], dataSources_name_input: [{
                type: Input,
                args: ['dataSources.name']
            }], dataSources_value_input: [{
                type: Input,
                args: ['dataSources.value']
            }], exportSettings_exportOptions_input: [{
                type: Input,
                args: ['exportSettings.exportOptions']
            }], exportSettings_excelFormat_input: [{
                type: Input,
                args: ['exportSettings.excelFormat']
            }], exportSettings_wordFormat_input: [{
                type: Input,
                args: ['exportSettings.wordFormat']
            }], exportSettings_customItems_input: [{
                type: Input,
                args: ['exportSettings.customItems']
            }], pageSettings_orientation_input: [{
                type: Input,
                args: ['pageSettings.orientation']
            }], pageSettings_paperSize_input: [{
                type: Input,
                args: ['pageSettings.paperSize']
            }], pageSettings_height_input: [{
                type: Input,
                args: ['pageSettings.height']
            }], pageSettings_width_input: [{
                type: Input,
                args: ['pageSettings.width']
            }], pageSettings_margins_input: [{
                type: Input,
                args: ['pageSettings.margins']
            }], pageSettings_hidePageOrientation_input: [{
                type: Input,
                args: ['pageSettings.hidePageOrientation']
            }], parameters_labels_input: [{
                type: Input,
                args: ['parameters.labels']
            }], parameters_name_input: [{
                type: Input,
                args: ['parameters.name']
            }], parameters_nullable_input: [{
                type: Input,
                args: ['parameters.nullable']
            }], parameters_prompt_input: [{
                type: Input,
                args: ['parameters.prompt']
            }], parameters_values_input: [{
                type: Input,
                args: ['parameters.values']
            }], parameterSettings_delimiterChar_input: [{
                type: Input,
                args: ['parameterSettings.delimiterChar']
            }], parameterSettings_popupHeight_input: [{
                type: Input,
                args: ['parameterSettings.popupHeight']
            }], parameterSettings_popupWidth_input: [{
                type: Input,
                args: ['parameterSettings.popupWidth']
            }], parameterSettings_itemWidth_input: [{
                type: Input,
                args: ['parameterSettings.itemWidth']
            }], parameterSettings_labelWidth_input: [{
                type: Input,
                args: ['parameterSettings.labelWidth']
            }], permissionSettings_dataSet_input: [{
                type: Input,
                args: ['permissionSettings.dataSet']
            }], permissionSettings_dataSource_input: [{
                type: Input,
                args: ['permissionSettings.dataSource']
            }], previewOptions_autoRender_input: [{
                type: Input,
                args: ['previewOptions.autoRender']
            }], previewOptions_dataSources_input: [{
                type: Input,
                args: ['previewOptions.dataSources']
            }], previewOptions_enableNotificationBar_input: [{
                type: Input,
                args: ['previewOptions.enableNotificationBar']
            }], previewOptions_enableVirtualEvaluation_input: [{
                type: Input,
                args: ['previewOptions.enableVirtualEvaluation']
            }], previewOptions_enableParameterBlockScroller_input: [{
                type: Input,
                args: ['previewOptions.enableParameterBlockScroller']
            }], previewOptions_enableDatasourceBlockScroller_input: [{
                type: Input,
                args: ['previewOptions.enableDatasourceBlockScroller']
            }], previewOptions_enableDropDownSearch_input: [{
                type: Input,
                args: ['previewOptions.enableDropDownSearch']
            }], previewOptions_exportSettings_input: [{
                type: Input,
                args: ['previewOptions.exportSettings']
            }], previewOptions_pageSettings_input: [{
                type: Input,
                args: ['previewOptions.pageSettings']
            }], previewOptions_parameters_input: [{
                type: Input,
                args: ['previewOptions.parameters']
            }], previewOptions_parameterSettings_input: [{
                type: Input,
                args: ['previewOptions.parameterSettings']
            }], previewOptions_printMode_input: [{
                type: Input,
                args: ['previewOptions.printMode']
            }], previewOptions_printOption_input: [{
                type: Input,
                args: ['previewOptions.printOption']
            }], previewOptions_sizeToReportContent_input: [{
                type: Input,
                args: ['previewOptions.sizeToReportContent']
            }], previewOptions_toolbarSettings_input: [{
                type: Input,
                args: ['previewOptions.toolbarSettings']
            }], previewOptions_zoomFactor_input: [{
                type: Input,
                args: ['previewOptions.zoomFactor']
            }], reportDataExtensions_name_input: [{
                type: Input,
                args: ['reportDataExtensions.name']
            }], reportDataExtensions_className_input: [{
                type: Input,
                args: ['reportDataExtensions.className']
            }], reportDataExtensions_imageClass_input: [{
                type: Input,
                args: ['reportDataExtensions.imageClass']
            }], reportDataExtensions_displayName_input: [{
                type: Input,
                args: ['reportDataExtensions.displayName']
            }], reportItemExtensions_name_input: [{
                type: Input,
                args: ['reportItemExtensions.name']
            }], reportItemExtensions_className_input: [{
                type: Input,
                args: ['reportItemExtensions.className']
            }], reportItemExtensions_imageClass_input: [{
                type: Input,
                args: ['reportItemExtensions.imageClass']
            }], reportItemExtensions_displayName_input: [{
                type: Input,
                args: ['reportItemExtensions.displayName']
            }], reportItemExtensions_category_input: [{
                type: Input,
                args: ['reportItemExtensions.category']
            }], reportItemExtensions_allowHeaderFooter_input: [{
                type: Input,
                args: ['reportItemExtensions.allowHeaderFooter']
            }], toolbarSettings_items_input: [{
                type: Input,
                args: ['toolbarSettings.items']
            }], toolbarSettings_showToolbar_input: [{
                type: Input,
                args: ['toolbarSettings.showToolbar']
            }], toolbarSettings_templateId_input: [{
                type: Input,
                args: ['toolbarSettings.templateId']
            }], ajaxBeforeLoad_output: [{
                type: Output,
                args: ['ajaxBeforeLoad']
            }], ajaxError_output: [{
                type: Output,
                args: ['ajaxError']
            }], ajaxSuccess_output: [{
                type: Output,
                args: ['ajaxSuccess']
            }], create_output: [{
                type: Output,
                args: ['create']
            }], destroy_output: [{
                type: Output,
                args: ['destroy']
            }], newDataClick_output: [{
                type: Output,
                args: ['newDataClick']
            }], openReportClick_output: [{
                type: Output,
                args: ['openReportClick']
            }], previewReport_output: [{
                type: Output,
                args: ['previewReport']
            }], reportModified_output: [{
                type: Output,
                args: ['reportModified']
            }], reportOpened_output: [{
                type: Output,
                args: ['reportOpened']
            }], reportSaved_output: [{
                type: Output,
                args: ['reportSaved']
            }], saveReportClick_output: [{
                type: Output,
                args: ['saveReportClick']
            }], toolbarClick_output: [{
                type: Output,
                args: ['toolbarClick']
            }], toolbarRendering_output: [{
                type: Output,
                args: ['toolbarRendering']
            }], encryptData_output: [{
                type: Output,
                args: ['encryptData']
            }], decryptData_output: [{
                type: Output,
                args: ['decryptData']
            }] } });

class BoldReportDesignerModule {
}
BoldReportDesignerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportDesignerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BoldReportDesignerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportDesignerModule, declarations: [BoldReportDesignerComponent], imports: [CommonModule], exports: [BoldReportDesignerComponent] });
BoldReportDesignerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportDesignerModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportDesignerModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [
                        BoldReportDesignerComponent
                    ],
                    exports: [
                        BoldReportDesignerComponent
                    ]
                }]
        }] });

class BoldReportsModule {
}
BoldReportsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BoldReportsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportsModule, imports: [CommonModule,
        BoldReportViewerModule,
        BoldReportDesignerModule], exports: [BoldReportViewerModule,
        BoldReportDesignerModule] });
BoldReportsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportsModule, imports: [[
            CommonModule,
            BoldReportViewerModule,
            BoldReportDesignerModule
        ], BoldReportViewerModule,
        BoldReportDesignerModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.0", ngImport: i0, type: BoldReportsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        BoldReportViewerModule,
                        BoldReportDesignerModule
                    ],
                    declarations: [],
                    exports: [
                        BoldReportViewerModule,
                        BoldReportDesignerModule
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ArrayTagElement, BoldReportComponents, BoldReportDesignerComponent, BoldReportDesignerModule, BoldReportViewerComponent, BoldReportViewerModule, BoldReportsModule, ComplexTagElement, Utils, currentTemplateElement };
//# sourceMappingURL=boldreports-angular-reporting-components.mjs.map
